#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

#define MAP_FILE_NAME "MAP02.PMF"

#define MAX_MAPF_SIZE 255

#define MAX_MAP_XSIZE 40
#define MAX_MAP_YSIZE 40

// Map fields
int n_mapf_size=MAX_MAPF_SIZE;
struct s_mapf {
				unsigned char m; // Map field properties
				unsigned char c; // Char
				unsigned char f,b; // Foreground, background color
			  } mapf[255];

// Game map
int n_map_xsize=MAX_MAP_XSIZE;
int n_map_ysize=MAX_MAP_YSIZE;
struct s_map {
			   char name[64]; // Map name
			   unsigned char m[MAX_MAP_XSIZE][MAX_MAP_YSIZE]; // Map fields properties
			   //unsigned char p[MAX_MAP_XSIZE][MAX_MAP_YSIZE];
			 } map;


void init_map()
// Initialise testing map
// This function will be replaced by function load_map() in future
{
  int ix,iy;

  // Map name
  strcpy(map.name,"Map1");

  // Initialise map fields
  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	map.m[ix][iy]=0; // Clear all map fields

	// Create map borders
	if ( (ix==0) || (iy==0) || (ix==(n_map_xsize-1)) || (iy==(n_map_ysize-1)) )
	  {  map.m[ix][iy]=1;  }
  }

  // Digging fields
  for (iy=1; iy<((n_map_ysize / 2)+1); iy++)
  for (ix=(n_map_xsize-(n_map_xsize / 2)); ix<(n_map_xsize-1); ix++)
  {
	map.m[ix][iy]=2;
  }

  // Eating fields
  for (iy=((n_map_ysize / 2)+2); iy<(n_map_ysize-1); iy++)
  for (ix=((n_map_xsize / 2)+2); ix<(n_map_xsize-1); ix++)
  {
	if (random(100)<5)
	  {  map.m[ix][iy]=3;  }
  }

  // Cross in center
  for (ix=(n_map_xsize / 5); ix<((n_map_xsize / 5)*2-4); ix++)
  {
	map.m[ix][(n_map_ysize / 2)]=1;
	map.m[(ix+((n_map_xsize / 5)*2)+4)][(n_map_ysize / 2)]=1;
  }

  for (iy=(n_map_ysize / 5); iy<((n_map_ysize / 5)*2-4); iy++)
  {
	map.m[(n_map_xsize / 2)][iy]=1;
	map.m[(n_map_xsize / 2)][(iy+((n_map_ysize / 5)*2)+4)]=1;
  }

  // Rectangle in center
  for (iy=((n_map_ysize / 5)*2); iy<((n_map_ysize / 5)*3); iy++)
  for (ix=((n_map_xsize / 5)*2); ix<((n_map_xsize / 5)*3); ix++)
  {
	if ( (ix==((n_map_xsize / 5)*2)) || (iy==((n_map_ysize / 5)*2))
	  || (ix==((n_map_xsize / 5)*3)-1) || (iy==((n_map_ysize / 5)*3)-1) )
	{
	  map.m[ix][iy]=1;
	}
	else
	{
	  map.m[ix][iy]=4;
	}
  }
}

void init_mapf()
{
  // m=0 ... normal playing field
  // m=1 ... wall
  // m=2 ... tuneler playing filed
  // m=3 ... eat

  mapf[0].m= 0; mapf[0].f= 1; mapf[0].b= 1; mapf[0].c=' ';
  mapf[1].m= 1; mapf[1].f=14; mapf[1].b=14; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 9; mapf[2].b= 1; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f=10; mapf[3].b= 1; mapf[3].c='O';
  mapf[4].m= 1; mapf[4].f= 8; mapf[4].b= 0; mapf[4].c='@';
  n_mapf_size=5;
}

void main()
{
  int i1,i2;
  FILE *out;

  printf("Pizdjozky map generator 1.0\n\n");

  printf("File name: %s\n", MAP_FILE_NAME);
  printf("x_size: %i\n", MAX_MAP_XSIZE);
  printf("y_size: %i\n", MAX_MAP_YSIZE);

  init_map();
  init_mapf();

  if ((out = fopen(MAP_FILE_NAME, "wt")) == NULL)
  {
	 printf("Cannot open output file.\n");
  }
  else
  {
	fprintf(out, "PMF10");

	// Map name
	//               12345678901234567890123456789012
	strcpy(map.name,"-=          Test map          =-");
	fprintf(out,map.name);
	/*for (i1=0; i1<32; i1++)
	{
	  fputc((97+i1),out);
	}*/

	// Mapf size
	fputc(n_mapf_size, out);

	// Map size
	fputc(MAX_MAP_XSIZE, out);
	fputc(MAX_MAP_YSIZE, out);

	// Players
	fputc(4, out);
	fputc(5, out); fputc(5, out); // Player1
	fputc((n_map_xsize-7), out); fputc((n_map_ysize-7), out); // Player2
	fputc((n_map_xsize-7), out); fputc(5, out); // Player3
	fputc(5, out); fputc((n_map_ysize-7), out); // Player4

	for (i1=0; i1<n_mapf_size; i1++)
	{
	  fputc(mapf[i1].m, out);
	  fputc(mapf[i1].c, out);
	  fputc(mapf[i1].f, out);
	  fputc(mapf[i1].b, out);
	}

	for (i2=0; i2<MAX_MAP_YSIZE; i2++)
	{
	  for (i1=0; i1<MAX_MAP_XSIZE; i1++)
	  {
		fputc(map.m[i1][i2], out);
	  }
	}
	fclose(out);

	printf("OK, map generated successfully.\n");
  }

  printf("\n\n");
}
